#include <stdio.h>
#include <stdlib.h>
#include <string.h>



static unsigned int get_word(unsigned char *p){
	return (p[0] | (p[1] << 8));
}

static unsigned long get_dword(unsigned char *p){
	return (p[0] | (p[1] << 8) | (p[2] << 16) | (p[3] << 24));
}



int main(int argc, char *argv[]){
	FILE *fi;
	long tbl_size;
	char *tbl;

	if(2 > argc){
		printf("pbx_cut.exe [infile]\n");
		exit(0);
	}

	{
		char buf[16];
		fi = fopen(argv[1], "rb");
		if(NULL == fi){
			printf("%s ݂܂\n", argv[1]);
			exit(1);
		}
		fread(buf, 1, 16, fi);
		if(memcmp(buf, "Pandora.box\0", 12) != 0){
			fclose(fi);
			printf("%s  pbx ł͂܂\n", argv[1]);
			exit(1);
		}
		tbl_size = get_word(buf + 12);
		fseek(fi, 0, SEEK_SET);
		tbl = malloc(tbl_size);
		if(NULL == tbl){
			fclose(fi);
			printf("sł\n");
			exit(1);
		}
		fread(tbl, 1, tbl_size, fi);
	}

	{
		FILE *fo;
		long ofs;
		long t_ofs, t_size;
		char t_name[16];
		char *buf;

		tbl_size -= 4;
		ofs = 12;
		while(ofs < tbl_size){
			t_ofs = get_dword(tbl + ofs);
			memset(t_name, 0, sizeof(t_name));
			memcpy(t_name, (tbl + ofs + 4), 12);
			ofs += 16;
			t_size = (get_dword(tbl + ofs) - t_ofs);
			printf("%-12s  %06x  %d\n", t_name, t_ofs, t_size);

			buf = malloc(t_size);
			if(NULL == buf){
				printf("sł\n");
				free(tbl);
				fclose(fi);
				exit(1);
			}

			fseek(fi, t_ofs, SEEK_SET);
			fread(buf, 1, t_size, fi);

			fo = fopen(t_name, "wb");
			fwrite(buf, 1, t_size, fo);
			fclose(fo);

			free(buf);
		}
	}

	free(tbl);
	fclose(fi);
	exit(0);
}
